#ifndef EFL_GENERATED_ECORE_IDLE_EXITER_HH
#define EFL_GENERATED_ECORE_IDLE_EXITER_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_idle_exiter.eo.h"
}


struct ecore_idle_exiter
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_idle_exiter(Eo* eo)
      : efl::eo::base(eo)
   {}

   ecore_idle_exiter(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_idle_exiter(_c0(_p))
   {}

   /// @param func 
   /// @param data 
   ///
   ecore_idle_exiter(Ecore_Task_Cb func, const void * data, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_idle_exiter(_c1(func, data, _p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_idle_exiter(ecore_idle_exiter const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~ecore_idle_exiter() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_IDLE_EXITER_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_IDLE_EXITER_CLASS, _p._eo_raw, eo_constructor());
   }

   static Eo* _c1(Ecore_Task_Cb func, const void * data, efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_IDLE_EXITER_CLASS, _p._eo_raw, ecore_idle_exiter_constructor(func, data));
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_idle_exiter >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_idle_exiter >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_idle_exiter>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::ecore_idle_exiter >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_idle_exiter, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_idle_exiter >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_idle_exiter, ::std::tuple<Ecore_Task_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_idle_exiter_constructor(args.get<0>(), args.get<1>()));
}

template<>
struct extension_inheritance< ::ecore_idle_exiter>
{
   template <typename T>
   struct type
   {
      operator ::ecore_idle_exiter() const
      {
         return ::ecore_idle_exiter(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_idle_exiter>)
{
   return (ECORE_IDLE_EXITER_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_IDLE_EXITER_HH

